function install

if exist('csim') ~= 3
  cd src
  fprintf('Compiling CSIM (this may take several minutes) ...');
  if  str2num(version('-release')) < 13
    if isunix
      mex -O -f cxxopts.sh csim.cpp csimclass.cpp csimmex.cpp randgen.cpp advanceable.cpp analogteacher.cpp staticspikingsynapse.cpp dynamicspikingsynapse.cpp staticstdpsynapse.cpp dynamicstdpsynapse.cpp stdpsynapse.cpp analogneuron.cpp analogsynapse.cpp staticanalogsynapse.cpp lifneuron.cpp network.cpp neuron.cpp spikingneuron.cpp spikinginputneuron.cpp spikingsynapse.cpp spikingteacher.cpp synapse.cpp teacher.cpp recorder.cpp mexrecorder.cpp csimerror.cpp analoginputneuron.cpp sigmoidalneuron.cpp linearneuron.cpp cbneuron.cpp ionchannel.cpp viongate.cpp conciongate.cpp iongate.cpp activechannel.cpp ahp_channel.cpp synapticchannel.cpp mexnetwork.cpp forceable.cpp hh_squid_channels.cpp hh_neuron.cpp extinputneuron.cpp extoutsigmoidalneuron.cpp extoutlinearneuron.cpp generic_ion_gates.cpp specific_ion_channels.cpp activecachannel.cpp cbneuronst.cpp extoutlifneuron.cpp csiminputclass.cpp membranepatch.cpp membranepatchsimple.cpp specific_neurons.cpp staticanalogcbsynapse.cpp dynamicspikingcbsynapse.cpp staticspikingcbsynapse.cpp cbstouneuron.cpp specificouneurons.cpp ionbuffer.cpp cbhhouneuron.cpp cbhhouineuron.cpp 
    elseif ispc
      mex -O -f mexopts.bat csim.cpp csimclass.cpp csimmex.cpp randgen.cpp advanceable.cpp analogteacher.cpp staticspikingsynapse.cpp dynamicspikingsynapse.cpp staticstdpsynapse.cpp dynamicstdpsynapse.cpp stdpsynapse.cpp analogneuron.cpp analogsynapse.cpp staticanalogsynapse.cpp lifneuron.cpp network.cpp neuron.cpp spikingneuron.cpp spikinginputneuron.cpp spikingsynapse.cpp spikingteacher.cpp synapse.cpp teacher.cpp recorder.cpp mexrecorder.cpp csimerror.cpp analoginputneuron.cpp sigmoidalneuron.cpp linearneuron.cpp cbneuron.cpp ionchannel.cpp viongate.cpp conciongate.cpp iongate.cpp activechannel.cpp ahp_channel.cpp synapticchannel.cpp mexnetwork.cpp forceable.cpp hh_squid_channels.cpp hh_neuron.cpp extinputneuron.cpp extoutsigmoidalneuron.cpp extoutlinearneuron.cpp generic_ion_gates.cpp specific_ion_channels.cpp activecachannel.cpp cbneuronst.cpp extoutlifneuron.cpp csiminputclass.cpp membranepatch.cpp membranepatchsimple.cpp specific_neurons.cpp staticanalogcbsynapse.cpp dynamicspikingcbsynapse.cpp staticspikingcbsynapse.cpp cbstouneuron.cpp specificouneurons.cpp ionbuffer.cpp cbhhouneuron.cpp cbhhouineuron.cpp 
    else
      disp('Unknown operating system! Terminated.'); return;
    end
  else
    if isunix
      mex -O csim.cpp csimclass.cpp csimmex.cpp randgen.cpp advanceable.cpp analogteacher.cpp staticspikingsynapse.cpp dynamicspikingsynapse.cpp staticstdpsynapse.cpp dynamicstdpsynapse.cpp stdpsynapse.cpp analogneuron.cpp analogsynapse.cpp staticanalogsynapse.cpp lifneuron.cpp network.cpp neuron.cpp spikingneuron.cpp spikinginputneuron.cpp spikingsynapse.cpp spikingteacher.cpp synapse.cpp teacher.cpp recorder.cpp mexrecorder.cpp csimerror.cpp analoginputneuron.cpp sigmoidalneuron.cpp linearneuron.cpp cbneuron.cpp ionchannel.cpp viongate.cpp conciongate.cpp iongate.cpp activechannel.cpp ahp_channel.cpp synapticchannel.cpp mexnetwork.cpp forceable.cpp hh_squid_channels.cpp hh_neuron.cpp extinputneuron.cpp extoutsigmoidalneuron.cpp extoutlinearneuron.cpp generic_ion_gates.cpp specific_ion_channels.cpp activecachannel.cpp cbneuronst.cpp extoutlifneuron.cpp csiminputclass.cpp membranepatch.cpp membranepatchsimple.cpp specific_neurons.cpp staticanalogcbsynapse.cpp dynamicspikingcbsynapse.cpp staticspikingcbsynapse.cpp cbstouneuron.cpp specificouneurons.cpp ionbuffer.cpp cbhhouneuron.cpp cbhhouineuron.cpp 
    elseif ispc
      mex -O csim.cpp csimclass.cpp csimmex.cpp randgen.cpp advanceable.cpp analogteacher.cpp staticspikingsynapse.cpp dynamicspikingsynapse.cpp staticstdpsynapse.cpp dynamicstdpsynapse.cpp stdpsynapse.cpp analogneuron.cpp analogsynapse.cpp staticanalogsynapse.cpp lifneuron.cpp network.cpp neuron.cpp spikingneuron.cpp spikinginputneuron.cpp spikingsynapse.cpp spikingteacher.cpp synapse.cpp teacher.cpp recorder.cpp mexrecorder.cpp csimerror.cpp analoginputneuron.cpp sigmoidalneuron.cpp linearneuron.cpp cbneuron.cpp ionchannel.cpp viongate.cpp conciongate.cpp iongate.cpp activechannel.cpp ahp_channel.cpp synapticchannel.cpp mexnetwork.cpp forceable.cpp hh_squid_channels.cpp hh_neuron.cpp extinputneuron.cpp extoutsigmoidalneuron.cpp extoutlinearneuron.cpp generic_ion_gates.cpp specific_ion_channels.cpp activecachannel.cpp cbneuronst.cpp extoutlifneuron.cpp csiminputclass.cpp membranepatch.cpp membranepatchsimple.cpp specific_neurons.cpp staticanalogcbsynapse.cpp dynamicspikingcbsynapse.cpp staticspikingcbsynapse.cpp cbstouneuron.cpp specificouneurons.cpp ionbuffer.cpp cbhhouneuron.cpp cbhhouineuron.cpp 
    else
      disp('Unknown operating system! Terminated.'); return;
    end
  end
  copyfile(['csim.' mexext],'..');
  delete(['csim.' mexext]);
  cd ..
  v=csim('version');
  fprintf('\b\b\b\b. Done.\nCSIM %s successfully compiled.\n',v);
else
  fprintf('csim.%s exists. No compilation necessary.\n',mexext);  
end

fprintf('CSIM *succesfully* installed.\n\n');
