function stimulus=generate(this,varargin)

nSegments = length(this.nTemplates);

switch this.templ_selection
   case 'random'
      ti = ceil(rand(1,nSegments).*this.nTemplates);
   case 'sequential'
      digit_base = [1 cumprod(this.nTemplates(1:end-1))];
      if nargin < 3
         i = floor(rand*prod(this.nTemplates));
      else
         i = max(varargin{2}-1,0);
      end
      ti = mod(floor(i./digit_base),this.nTemplates)+1;
   otherwise
      err_str = sprintf('Template selection ''%s'' unknown!',this.templ_selection);
      error(err_str)
end


tau_refract=0e-3;

for j=1:this.nChannels
  st = [];
  for s=1:nSegments

     if j <= ceil(this.nChannels)/2
        f = this.nTemplates(s)+1-ti(s);
     else
        f = ti(s);
     end

     stt = [];
     stt = cumsum(tau_refract+exponentialrnd(1/this.freq(f)-tau_refract,1,ceil(5*this.freq(f)*this.Tstim)));
     stt = stt(stt<=this.Tstim/nSegments);
     stt = stt+(s-1)*this.Tstim/nSegments;

     st =  [st stt];
  end

  stimulus.channel(j).data    = st;
  stimulus.channel(j).spiking = 1;
  stimulus.channel(j).dt      = -1;
end

stimulus.info(1).Tstim          = this.Tstim;
stimulus.info(1).actualTemplate = ti;
