function this = jittered_templates_dft(varargin)

%
%  Author: Thomas Natschlaeger, 11/2001, tnatschl@igi.tu-graz.ac.at
%

this.description     = 'randomly flipped frequencies between both halves input channels';


this.nChannels         = 4;
this.nChannels_comment = 'number of spike trains (channels)';

this.Tstim            = 0.5;
this.Tstim_comment    = 'length of spike trains';

this.jitter          = 0;
this.jitter_comment  = 'not implemented';

this.nTemplates      = [2];
this.nTemplates_comment  = 'number frequencies between that is flipped';

this.templ_selection  = 'random';
this.templ_selection_comment = 'select templates ''sequential'' or ''random'' ';

this.freq            = [0 40];
this.freq_comment    = 'frequency between that is flipped';

this.nSpikes         = [];
this.nSpikes_comment = 'not implemented';

this.segment         = struct([]);
this.segment_comment = 'stores the actual spike templates';

this.public_properties = { 'jitter' 'nChannels' 'Tstim' 'nTemplates' 'templ_selection' 'freq' 'nSpikes' 'segment'};

[pathstr,name,ext,versn] = fileparts(mfilename);
if nargin == 0
  this = class(this,name);
elseif isa(varargin{1},name)
  this = varargin{1};
else
  this = class(this,name);
  this = set(this,varargin{:});
end

this=generate_templates(this);
