function this = random_mod_rate(varargin)

this.description     = 'genarates spike trains with a rate modulated by a sinusoidal rate r(t) whose frequency is drawn randomly';

this.nChannels         = 4;
this.nChannels_comment = 'number of spiking channels';

this.Tstim             = -1; % if set to -1 we set Tstim to Tmax (in generate.m)
this.Tstim_comment     = 'length of stimulus (-1 ... specify the length in the call to generate)';

this.freq              = 40;
this.freq_comment      = 'frequency od the underlying signal';

this.fmax              = 80;
this.fmax_comment      = 'maximal modulation frequency';

this.fmin              = 0;
this.fmax_comment      = 'minimal modulation frequency';

this.binwidth          = 30e-3;
this.binwidth_comment  = 'in each interval of length binwidth a new modulation frequency is drawn'; 

this.nRates            = Inf;
this.nRates_comment    = 'number of different modulation frequencies that can be chosen (equal spaced in the interval [0,fmax]';

this.public_properties = { 'nChannels' 'Tstim' 'fmax' 'fmin' 'binwidth' 'nRates' 'freq'};


[pathstr,name,ext,versn] = fileparts(mfilename);

if nargin == 0
  this = class(this,name);
elseif isa(varargin{1},name)
  this = varargin{1};
else
  this = class(this,name);
  this = set(this,varargin{:});
end
