function [mae,mse,cc,score]=performace(this,stimuli,dataType,varargin)

if ~isfield(this.preprocess,'P')
  if nargout == 0
    fprintf('this readout has not been trained yet!');
  end
  [mae,mse,cc,score] = deal(NaN);
  return
end

if strcmp('precalcstates',lowerclean(dataType))
  ts.X = vertcat(varargin{1}(:).X);

  tmp(length(stimuli)).y = [];
  for i=1:length(stimuli)
    tmp(i).y = target_values(this.targetFunction,stimuli(i),varargin{1}(i).t);
  end
  ts.Y = vertcat(tmp(:).y);
  clear tmp


  if ~isempty(this.preprocess.P)
    ts.X = apply_pca(ts.X,this.preprocess.P);
  end
  
  if ~isempty(this.preprocess.meanx)
    ts.X = apply_stdnorm(ts.X,this.preprocess.meanx,this.preprocess.stdx); 
  end

  r = get(this.algorithm,'range');
  ts.Y = (ts.Y-this.preprocess.b)/this.preprocess.a*diff(r)+r(1);

  [mae,mse,cc,score] = analyse(this.algorithm,ts);

  if nargout == 0
    verbose(0,'performance: cc=%g, mae=%g, mse=%g, score=%g\n',cc,mae,mse,score);
  end

elseif strcmp('samplestates',lowerclean(dataType))

  states = feval(varargin{1},stimuli,varargin{2:end});
  
  [mae,mse,cc,score]=performace(this,stimuli,'precalc_states',states);
  
end

