function this = voted_perceptron(varargin)
%
% Copyright (c) by Anton Schwaighofer (2001)
% $Revision: 1.1 $ $Date: 2001/12/19 10:38:44 $
% mailto:anton.schwaighofer@gmx.net
%
% Implemented by Stefan Haeusler 2003/05/09 (haeusler@igi.tu-graz.ac.at)

this.name              = 'voted_perceptron';
this.description       = 'classification based on voted perceptron';
this.abbrev            = 'vperc';
this.time              = -1;
this.time_comment      = 'time (in sec) needed to train the classifier';
this.range             = [-1 +1];
this.range_comment     = 'possible label range; e.g. [-1 +1].';
this.kernel            = [];
this.kernel_comment    = 'kernel';
this.margin            = [0 0];
this.margin_comment    = 'margin';
this.learnrate         = 10;
this.learnrate_comment = 'learn rate';
this.maxepoch          = 100;
this.maxepoch_comment  = 'maximal epochs';
this.votes             = 1;
this.votes_comment     = 'number of voting perceptrons';
this.voting            = 'avgweight';
this.voting_comment    = 'voting schemes ''avgweight'' or ''majority''';
this.verbosity         = 0;
this.verbosity_comment = 'verbosity level';
this.net         = [];
this.net_comment     = 'internal used structure';




if nargin == 0
  this = class(this,this.name);
elseif isa(varargin{1},this.name)
  this = varargin{1};
else
  this = class(this,this.name);
  this = set(this,varargin{:});
end
