function [] = plot_spike_raster(R,C,S1,S2)

 INH = 1;
 EXC = 2;
 Tmax = R{1}.R{1}.Tsim;

 figure
   nsp = 1;
   for nR = 1:length(R{1}.R)
      if strcmp(R{1}.R{nR}.channel(1).fieldName,'spikes')
         subplot(3,1,nsp)
         hold on

         neuronIdx = get(C.circuit,'pool',{nsp},'neuronIdx');                                       
         neuronType = csim('get',neuronIdx,'type');
         excIdx = find(neuronType == EXC);
         inhIdx = find(neuronType == INH);

          
         eh = []; ih = []; 

         for nCh = 1:length(excIdx)
	    h = plot(R{1}.R{nR}.channel(excIdx(nCh)).data,excIdx(nCh)*ones(size(R{1}.R{nR}.channel(excIdx(nCh)).data)),'k.');
            eh = [eh h']; 
	 end
         for nCh = 1:length(inhIdx)
	    h = plot(R{1}.R{nR}.channel(inhIdx(nCh)).data,inhIdx(nCh)*ones(size(R{1}.R{nR}.channel(inhIdx(nCh)).data)),'r.');
            ih = [ih h']; 
	 end

         axis tight
         xlim([0 Tmax])

         if (nsp == 2)&&~isempty(eh)&&~isempty(ih)
            legend([eh(1) ih(1)],{'Exc','Inh'})
         end     

         nsp = nsp + 1;
      end
   end

   subplot(311)
   title('Spike raster layer 2/3')
   subplot(312)
   title('Spike raster layer 4')
   subplot(313)
   title('Spike raster layer 5')
   xlabel('time [sec]')
   
 
   figure
   nsp = 1;
   for nR = 1:length(R{1}.R)
      if strcmp(R{1}.R{nR}.channel(1).fieldName,'spikes')

         clear mfr nst
         ncount = 0;

         for nCh = 1:length(R{1}.R{nR}.channel)

            R{1}.R{nR}.channel(nCh).data = R{1}.R{nR}.channel(nCh).data(R{1}.R{nR}.channel(nCh).data>0.1);

            if isempty(R{1}.R{nR}.channel(nCh).data) 
               mfr(nCh) = 0;
               nst(nCh) = 0;
            else
               ncount = ncount + 1;
               nst(nCh) = length(R{1}.R{nR}.channel(nCh).data);
               if length(R{1}.R{nR}.channel(nCh).data) > 1
                  mfr(nCh) = (length(R{1}.R{nR}.channel(nCh).data) - 1 )/...
                           (R{1}.R{nR}.channel(nCh).data(end) - R{1}.R{nR}.channel(nCh).data(1));
               else
                  mfr(nCh) = 0;
               end
            end
         end

         subplot(3,2,nsp*2-1)
         hold on
         plot(mfr,'b.')
         title(sprintf('%i neurons (%g %%) active',ncount,round(100*ncount/nCh)))
         axis tight
         ylabel('mfr [Hz]')
         if (nsp == 3), xlabel('neuron idx'); end

         subplot(3,2,nsp*2)
         hold on

         nstc = nst/(Tmax-0.1);

         nhx = [0:(max(nstc)/10):max(nstc)];
         nhy = histc(nstc,nhx);

         bar(nhx,nhy)

         disp(mean(nstc))

         xlim([-5 100])
         ylabel('# neurons')
         if (nsp == 3), xlabel('firing rate [Hz]'); end

         nsp = nsp + 1;
      end
   end


