function [W,C] = set_connection_matrix(Rm,C1,C2,C3)

global VERBOSE_LEVEL

C = [0.26  0.21  0.00  0.08  0.55  0.00;...
     0.16  0.25  0.00  0.00  0.20  0.00;...
     0.28  0.10  0.17  0.19  0.00  0.00;...
     0.50  0.20  0.10  0.50  0.00  0.00;...
     0.03  0.00  0.00  0.00  0.09  0.10;...
     0.00  0.00  0.00  0.00  0.12  0.60];


% NOTE: for LIF neurons weights of inhibitory neurons must be negativ

%     -0.65 -1.35 -0.00 -0.00 -1.30*7 -0.00;...

W = [ 1.70  1.90  0.00  1.60  1.40  0.00;...
     -0.65 -1.35 -0.00 -0.00 -1.30*4 -0.00;...
      4.00  0.15  1.10  3.70  0.00  0.00;...
     -1.75 -1.50 -0.85 -1.55 -0.00 -0.00;...
      0.30  0.00  0.00  0.00  1.70  0.90;...
     -0.00 -0.00 -0.00 -0.00 -1.20 -1.20]*1e-3/Rm;	% Weights correspond to max PSC

if (C1)

  disp('Weight correction 1: Dantsker / Callaway 5E -> 23E'); pause(0.5)

  W(5,1) = 3.2*1e-3/Rm;
  C(5,1) = 0.07;

end
if (C2)

  disp('Weight correction 2: Dantsker / Callaway 5E -> 23I'); pause(0.5)

  W(5,2) = 2.5*1e-3/Rm;
  C(5,2) = 0.2;
end
if (C3)

  disp('Weight correction 3: Dantsker / Callaway 4E -> 23I'); pause(0.5)

  W(3,2) = 4*1e-3/Rm;
  C(3,2) = 0.27;
end

if VERBOSE_LEVEL
   W
end

global connectivity_matrix
connectivity_matrix = C;


